(function ($, Drupal) {
    'use strict';

    Drupal.bpmn_io = {};

    Drupal.behaviors.bpmn_io = {
        attach: function (context, settings) {
            if (Drupal.bpmn_io.modeller === undefined) {
                Drupal.bpmn_io.modeller = window.modeller;
                Drupal.bpmn_io.loader = Drupal.bpmn_io.modeller.get('elementTemplatesLoader');
                Drupal.bpmn_io.loader.setTemplates(settings.bpmn_io.templates);
                Drupal.bpmn_io.open(settings.bpmn_io.bpmn);
                $('#bpmn-io input.button').click(Drupal.bpmn_io.export);
            }
        }
    };

    Drupal.bpmn_io.export = async function () {
        let result = await Drupal.bpmn_io.modeller.saveXML({format: true});
        let request = Drupal.ajax({
            url: '/admin/config/workflow/eca/' + drupalSettings.bpmn_io.modeller + '/save',
            submit: result.xml,
            progress: {
                type: 'fullscreen',
                message: Drupal.t('Saving model...'),
            },
        });
        request.execute();
    }

    Drupal.bpmn_io.open = async function (bpmnXML) {
        await Drupal.bpmn_io.modeller.importXML(bpmnXML);
        Drupal.bpmn_io.canvas = Drupal.bpmn_io.modeller.get('canvas');
        Drupal.bpmn_io.overlays = Drupal.bpmn_io.modeller.get('overlays');
        Drupal.bpmn_io.canvas.zoom('fit-viewport');
    }

})(jQuery, Drupal);
