<?php

namespace Drupal\bpmn_io\Plugin\ECA\Modeller;

use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\eca_modeller_bpmn\ModellerBpmnBase;

/**
 * Plugin implementation of the ECA Modeller.
 *
 * @EcaModeller(
 *   id = "bpmn_io",
 * )
 */
class BpmnIo extends ModellerBpmnBase {

  use StringTranslationTrait;

  /**
   * {@inheritdoc}
   */
  protected function xmlNsPrefix(): string {
    return 'bpmn2:';
  }

  /**
   * {@inheritdoc}
   */
  public function isEditable(): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function edit(): array {
    return [
      '#type' => 'container',
      '#attributes' => [
        'id' => 'bpmn-io',
      ],
      'canvas' => [
        '#prefix' => '<div class="canvas"></div><div class="property-panel"></div>',
      ],
      'actions' => [
        'save' => [
          '#type' => 'button',
          '#value' => $this->t('Save'),
        ],
      ],
      '#attached' => [
        'library' => [
          'bpmn_io/ui',
        ],
        'drupalSettings' => [
          'bpmn_io' => [
            'id' => $this->eca->id(),
            'modeller' => 'bpmn_io',
            'bpmn' => $this->eca->getModel()->getModeldata(),
            'templates' => $this->getTemplates(),
          ],
        ],
      ],
      'tb' => $this->tokenBrowserService->getTokenBrowserMarkup(),
    ];
  }

}
